#include "characters.h"

characters::characters(Graphics& gfx):
	gfx(gfx)
{
	
}

//Scribe Function Implementations:
void characters::scribe(int charCode, int x, int y, Color charColor, int scalar){
	int xPoint = 0; int yPoint = 0;
	if(charCode < 26){ //If the charCode is that of a letter.
		//Charmap Reader
		for(int i = 0; i < 25; i++){
			if(letters[charCode][i] == 1){
				//Charmap Interpreter
				for(int ny = 0; ny < scalar; ny++){
					for(int nx = 0; nx < scalar; nx++){
						gfx.PutPixel(x + nx + xPoint * scalar, y + ny + yPoint * scalar, charColor);
					}
				}
			}
			if(xPoint == 4){
				xPoint = 0;
				yPoint++;
			}else{
				xPoint++;
			}
		}
	}else if(charCode < 36){ //If the charCode is that of a number.
		for(int i = 0; i < 25; i++){
			if(numbers[charCode - 26][i] == 1){
				//Charmap Interpreter
				for(int ny = 0; ny < scalar; ny++){
					for(int nx = 0; nx < scalar; nx++){
						gfx.PutPixel(x + nx + xPoint * scalar, y + ny + yPoint * scalar, charColor);
					}
				}
			}
			if(xPoint == 4){
				xPoint = 0;
				yPoint++;
			}else{
				xPoint++;
			}
		}
	}else{ //If the charCode is that of anything else (ie. a symbol).
		for(int i = 0; i < 25; i++){
			if(symbols[charCode - 36][i] == 1){
				//Charmap Interpreter
				for(int ny = 0; ny < scalar; ny++){
					for(int nx = 0; nx < scalar; nx++){
						gfx.PutPixel(x + nx + xPoint * scalar, y + ny + yPoint * scalar, charColor);
					}
				}
			}
			if(xPoint == 4){
				xPoint = 0;
				yPoint++;
			}else{
				xPoint++;
			}
		}
	}
}
void characters::word_scribe(int word, int x, int y, Color wColor, int scalar, int gap, int length){
	for(int i = 0; i < length; i++){
		scribe(words[word][i], x + i * ((5 * scalar) + gap) - 1, y, wColor, scalar);
	}
}